<?php
	/*
	Copyright 2008  Ben Pike  (email : beejay@perthmatrix.com)

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

	Plugin Name: Servage Referral Widget
	Plugin URI: http://www.techgremlin.com/servage-referral-widget/
	Description: Display a servage referral link
	Author: Ben Pike
	Author URI: http://www.techgremlin.com/
	Version: 1.21
	*/

// Put functions into one big function well call at the plugins_loaded
// action. This ensures that all required plugin functions are defined.
function widget_servage_init() {

// Check for the required plugin functions. This will prevent fatal
// errors occurring when you deactivate the dynamic-sidebar plugin.
if ( !function_exists('register_sidebar_widget') )
return;



// This is the function that outputs our servage widget.
function widget_servage($args) {

// $args is an array of strings that help widgets to conform to
// the active theme: before_widget, before_title, after_widget,
// and after_title are the array keys. Default tags: li and h2.
extract($args);

// Each widget can store its own options. We keep strings here.
$options = get_option('widget_servage');
$title = $options['title'];
$customer = $options['customer'];
$sclickcount = $options['sclickcount'];

// These lines generate our output.
echo $before_widget . $before_title . $title . $after_title;
echo '<div style="margin:5px 0;"><a href="http://'.$_SERVER['SERVER_NAME'] . $_SERVER['PHP_SELF'].'?sclickcount=1" target="_blank"><img src="http://'.$_SERVER['SERVER_NAME'].'/wp-content/plugins/servage-widget/servage.gif" border="0" alt="Servage"/></a></div>';
echo $after_widget;
}

// This is the function that outputs the form to let the users edit
// the widgets options.
function widget_servage_control() {

// Get our options and see if were handling a form submission.
$options = get_option('widget_servage');

//Set the default options for the widget here

if ( !is_array($options) ){
	$options = array('title'=>'Servage', 'customer'=>'CUST00000', 'sclickcount'=>'0');
}

if ( $_POST['servage-submit'] ) {

// Remember to sanitize and format use input appropriately.
$options['title'] = strip_tags(stripslashes($_POST['servage-title']));
$options['customer'] = strip_tags(stripslashes($_POST['servage-customer']));
$options['sclickcount'] = strip_tags(stripslashes($_POST['servage-sclickcount']));

update_option('widget_servage', $options);
}

// Be sure you format your options to be valid HTML attributes.
$title = htmlspecialchars($options['title'], ENT_QUOTES);
$customer = htmlspecialchars($options['customer'], ENT_QUOTES);
$sclickcount = htmlspecialchars($options['sclickcount'], ENT_QUOTES);

// Here is our little form segment. Notice that we dont need a
// complete form. This will be embedded into the existing form.
echo '<p style="text-align:right;"><label for="servage-title">' . __('Title:') . ' <input style="width: 200px;
" id="servage-title" name="servage-title" type="text" value="'.$title.'" /></label></p>';

echo '<p style="text-align:right;"><label for="servage-customer">' . __('Customer ID:') . ' <input style="width: 200px;
" id="servage-customer" name="servage-customer" type="text" value="'.$customer.'" /></label></p>';

echo '<p style="text-align:right;"><label for="servage-sclickcount">' . __('How many times the link has been clicked:') . ' <input style="width: 50px;
" id="servage-sclickcount" name="servage-sclickcount" type="text" readonly="readonly" value="'.$sclickcount.'" /></label></p>';

//Uncomment the below line and comment out the above echo statement if you do not wish to view the clicks.
//echo '<input id="servage-sclickcount" name="servage-sclickcount" type="hidden" value="'.$sclickcount.'" />';

echo '<input type="hidden" id="servage-submit" name="servage-submit" value="1" />';
} 

 // This registers our widget so it appears with the other available
// widgets and can be dragged and dropped into any active sidebars.
register_sidebar_widget(array('Servage Widget', 'widgets'), 'widget_servage');

// This registers our optional widget control form. Because of this
// our widget will have a button that reveals a 300100 pixel form.
register_widget_control(array('Servage Widget', 'widgets'), 'widget_servage_control', 300, 100);


//clickcount is by itself out here, it works so we'll leave it here.
if ( $_GET['sclickcount'] == 1)
{
	
	//Retrieves the stores values.
	$options = get_option('widget_servage');
	
	//Retrieves the customer value used below and assigns a variable.
	$customer = $options['customer'];
	
	//Advances the click count by 1
	$options['sclickcount']++;
	
	//Saves the values back in.
	update_option('widget_servage', $options);
	
	//Redirects the page to the destination
	header("Location: http://www.servage.net/?coupon=" . $customer);
	exit();
}

}



// Run our code later in case this loads prior to any required plugins.
add_action('widgets_init', 'widget_servage_init');

?>